/* main.C
 * Contains the main() function
 */

void aint_init(int argc, char **argv, char ** envp);
void execute(void);
void aint_done(void);

int main(int argc, char **argv, char **envp)
{
  /* aint_init() initializes aint structures, parses args and calls
   * the backend initialization routines
   */
  aint_init(argc, argv, envp);

  /* the main exec loop */
  execute();

  /* cleanup, print statistics and exit */
  aint_done();
}
