MAIN_ENV


#define SIZE 64
#define NPROC param_nproc

int param_nproc = 2;

int *A;

struct {
    BARDEC(barrier)
} *stuff;

#define global  /* nada */

#include <stdio.h>
#include <math.h>
#include <time.h>

usema_t *global_lock;
volatile int *last;

void SlaveStart()
{
    int my_id;
    int i;
    int total = 0;

    GET_PID(my_id);

    if (my_id == 0) {
      ALLOCATEWRITETHROUGHENTRY((long)A, 0);
      for (i = 0; i<SIZE; i++) {
	A[i] = i + 10;
	total += A[i];
      }
      SENDSIGNAL(0, 2);
      WAITSIGNAL(2);
      DEALLOCATEWRITETHROUGHENTRY((long)A);
      for (i = 0; i<SIZE; i++) {
	A[i] = i + 20;
	total += A[i];
      }
      SENDSIGNAL(0, 2);
    }
    else {
      WAITSIGNAL(2);
      for (i = 0; i<SIZE; i++) {
	total += A[i];
      }
      SENDSIGNAL(1, 2);
      WAITSIGNAL(2);
      for (i = 0; i<SIZE; i++) {
	total += A[i];
      }
    }
    fprintf(stderr, "** [%d] - Finished with computations. total is %d\n", my_id, total); fflush(stderr);
}

main(argc, argv)
int argc;
char **argv;
{
   unsigned ProcessId = 0;
   int i;


   MAIN_INITENV(NPROC, (SIZE * sizeof(int)));
   
   A = (int *)G_MALLOC(sizeof(int) * SIZE);
   stuff = G_MALLOC(sizeof(stuff));
   BARINIT(stuff->barrier);

   for(i = 0; i < SIZE; i++)
     A[i] = 0;

   for(ProcessId = 1; ProcessId < NPROC; ProcessId++) {
      CREATE(SlaveStart);
   }
   SlaveStart();
   
   WAIT_FOR_END(NPROC-1);
   printf("main thread done waiting for kids...\n"); fflush(stdout);
   MAIN_END;
}
