#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
  int n, count;

  sscanf(argv[1], "%d", &n);
  count = 0;

  Hanoi(n, 1, 2, 3, &count);

  printf("%d Moves\n", count);
}

int Hanoi(int n, int from, int to, int temp, int *count)
{
  if (n == 1) {(*count)++; return;}

  Hanoi(n-1, from, temp, to, count);

  (*count)++;

  Hanoi(n-1, temp, to, from, count);
}

